//+------------------------------------------------------------------+
//|                                                      Service.mqh |
//|                                                            Radix |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Radix"
#property link      "http://www.mql5.com"
#property version   "1.05"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class Service
  {
private:

public:
   int               LogHandle;                 //   
protected:
//-!-!-  -!-!-

//    
   string            Symb;                      //      
   ENUM_TIMEFRAMES   Stf;                       //     
//  
   MqlTick           LastTick;
//  Rates Stf
   double            StfRatesHigh[];
   double            StfRatesLow[];
   double            StfRatesOpen[];
   double            StfRatesClose[];
   datetime          StfRatesTime[]; 
//+++------------------------------------------------------------------+++
//---    Stf
   int               Stf_ATR_Long_Handle;       //   ATR Long
   int               Stf_DEMA1_Handle;          //  DEMA1
   int               Stf_EMARSI_Handle;         //  EMA RSI VA
//     Stf
   double            Stf_ATR_Long_Val[];        //      ATR Long
   double            Stf_DEMA1_Val[];           //      DEMA1
   double            Stf_EMARSI_Val[];          // EMA RSI VA
   
   double   PercentStop;
   double   PercentTake;
   
   double   FixedVolume;                     //    
   int      MinFreeBabla;                    //      
   double   BaseLotSize;                     //    
   double   TradeVolume;                     //    
   MqlTradeRequest   TRequest;               //         
   MqlTradeResult    TResult;                //          
//+++------------------------------------------------------------------+++
public:
// /
                     Service();
                    ~Service();
//-!-!-  -!-!-
//   
   bool              LogCreate();

   void              SetSymTime(string symbol,ENUM_TIMEFRAMES smallTF)
                     {Symb=symbol; Stf=smallTF;}
//     Stf
   bool              CheckNewBar();
//     M1
   bool              CheckNewM1();
//     
   void              ShowError(string msg,int ercode);
//   "Sell"
   void              DrawArrowDown();
//   "Buy"
   void              DrawArrowUp();
//+++------------------------------------------------------------------+++
// 
//  
   void              GetRates();
// 
//     
   void              DoIndInit(int Stf_ATR_long_period, int Stf_DEMA1_per, int Stf_EMARSI_rsi, int Stf_EMARSI_ema);
   void              DeIndInit();
//   
   void              GetIndBuffers();

//    
   void              GetTradeParams(double baselotsize, int minfreebabla, int percentstop, int percenttake, double fixedvolume);

//   SL  ATR
   double            SLCountATR();
//   TP  ATR
   double            TPCountATR();



//---  
   int               OpenTrade(ENUM_ORDER_TYPE otype, double lot, double price, double sl, double tp);

//   EMA RSI+++
   int               PatEMARSIPlus();
// .    EMARSIPlus
int                  ExecuteEMARSIPlus();
  };
//+++------------------------------------------------------------------+++
Service::Service()
  {

  }
//+++------------------------------------------------------------------+++
Service::~Service()
  {
   
  }
//+++------------------------------------------------------------------+++
//   
bool Service::LogCreate()
  {
//   datetime StartTime=TimeCurrent();
//   string StartDate=TimeToString(StartTime,TIME_DATE);
//   string StartMinutes=TimeToString(StartTime,TIME_MINUTES);
   string LogName="Logzzz\\RefreshLog.txt";
   LogHandle=FileOpen(LogName,FILE_WRITE|FILE_CSV,0,CP_ACP);
   FileWrite(LogHandle,"   : ",TimeCurrent());
   if(LogHandle<0)
     {
      string Errormsg = "   :";
      int Errcode = GetLastError();
      ShowError(Errormsg,Errcode);
      return(false);
     }
   else
     {
      Print("  : ",LogName);
      return(true);
     }
  }
//+++------------------------------------------------------------------+++
//     M1
bool Service::CheckNewM1()
  {
   MqlRates BarRate[1];
   ArraySetAsSeries(BarRate,true);
   if(CopyRates(_Symbol,PERIOD_M1,0,1,BarRate)<0)
   {
      FileWrite(LogHandle,"  / : ",GetLastError()," !!!");
      return(false);
   }
   static datetime PreTime;
   if(PreTime==BarRate[0].time)
     {
      return(false);
     }
   else
     {
//      FileWrite(LogHandle,"   Stf: ",BarRate[0].time);
      PreTime = BarRate[0].time;
      return(true);
     }
  } //  checkNewBar()
//+++------------------------------------------------------------------+++
//     Stf
bool Service::CheckNewBar()
  {
   MqlRates BarRate[1];
   ArraySetAsSeries(BarRate,true);
   if(CopyRates(_Symbol,Stf,0,1,BarRate)<0)
   {
      FileWrite(LogHandle,"  / : ",GetLastError()," !!!");
      return(false);
   }
   static datetime PreTime;
   if(PreTime==BarRate[0].time)
     {
      return(false);
     }
   else
     {
      FileWrite(LogHandle,"   Stf: ",BarRate[0].time);
      PreTime = BarRate[0].time;
      return(true);
     }
  } //  checkNewBar()
//+++------------------------------------------------------------------+++c
//     
void Service::ShowError(string msg,int ercode)
  {
   FileWrite(LogHandle,msg, " - :", ercode, "!!!!");
   Alert(msg, " - :", ercode, "!!!!");
  }
//+++------------------------------------------------------------------+++c
/*
//---    ---
void Service::DrawArrowDown()
  {
   string ArrowDown=TimeToString(StfRatesTime[1],TIME_DATE)+" "+TimeToString(StfRatesTime[1],TIME_MINUTES);
   Print("   Sell: ",ArrowDown);
   if(!ObjectCreate(0,ArrowDown,OBJ_ARROW_SELL,0,StfRatesTime[1],StfRatesHigh[1]))
         {
            Errormsg = "   ArrowSell:";
            Errcode = GetLastError();
            showError(Errormsg,Errcode);
         }
  }
//---    ---
void Service::DrawArrowUp()
  {
   string ArrowUp=TimeToString(StfRatesTime[1],TIME_DATE)+" "+TimeToString(StfRatesTime[1],TIME_MINUTES);
   Print("   Buy: ",ArrowUp);
   if(!ObjectCreate(0,ArrowDown,OBJ_ARROW_BUY,0,StfRatesTime[1],StfRatesLow[1]))
         {
            Errormsg = "   ArrowBuy:";
            Errcode = GetLastError();
            showError(Errormsg,Errcode);
         }
  }
*/
//+++------------------------------------------------------------------+++
//+++------------------------------------------------------------------+++
//+++------------------------------------------------------------------+++
//  
void Service::GetRates()
   {
//--- Stf
      if(CopyHigh(Symb,Stf,0,300,StfRatesHigh)<0)
         {
            string Errormsg = "  MqlRates:";
            int Errcode = GetLastError();
            ShowError(Errormsg,Errcode);
         }
      if(CopyLow(Symb,Stf,0,300,StfRatesLow)<0)
         {
            string Errormsg = "  MqlRates:";
            int Errcode = GetLastError();
            ShowError(Errormsg,Errcode);
         }
      if(CopyOpen(Symb,Stf,0,300,StfRatesOpen)<0)
         {
            string Errormsg = "  MqlRates:";
            int Errcode = GetLastError();
            ShowError(Errormsg,Errcode);
         }
      if(CopyClose(Symb,Stf,0,300,StfRatesClose)<0)
         {
            string Errormsg = "  MqlRates:";
            int Errcode = GetLastError();
            ShowError(Errormsg,Errcode);
         }
      if(CopyTime(Symb,Stf,0,300,StfRatesTime)<0)
         {
            string Errormsg = "  MqlRates:";
            int Errcode = GetLastError();
            ShowError(Errormsg,Errcode);
         }

   } //  getRates
//+++------------------------------------------------------------------+++

//+++------------------------------------------------------------------+++
//+++------------------------------------------------------------------+++
//   ,       
void Service::DoIndInit(int Stf_ATR_long_period, int Stf_DEMA1_per, int Stf_EMARSI_rsi, int Stf_EMARSI_ema)
  {
//     Stf
   Stf_ATR_Long_Handle=iATR(Symb,Stf,Stf_ATR_long_period);
   Stf_DEMA1_Handle=iDEMA(Symb,Stf,Stf_DEMA1_per,0,PRICE_WEIGHTED);
   Stf_EMARSI_Handle=iCustom(Symb,Stf,"Examples\\EMA_RSI_VA",Stf_EMARSI_rsi,Stf_EMARSI_ema,PRICE_WEIGHTED);
//---   
   if(Stf_ATR_Long_Handle<0)
     {
      string Errormsg = "   ATR:";
      int Errcode = GetLastError();
      ShowError(Errormsg,Errcode);
     }
   if(Stf_DEMA1_Handle<0)
     {
      string Errormsg = "   DEMA:";
      int Errcode = GetLastError();
      ShowError(Errormsg,Errcode);
     }
   if(Stf_EMARSI_Handle<0)
     {
      string Errormsg = "   EMA RSI VA:";
      int Errcode = GetLastError();
      ShowError(Errormsg,Errcode);
     }
//---      
//  Stf
   ArraySetAsSeries(Stf_ATR_Long_Val,true);
   ArraySetAsSeries(Stf_DEMA1_Val,true);
   ArraySetAsSeries(Stf_EMARSI_Val,true);

//---      
// Rates Stf
   ArraySetAsSeries(StfRatesHigh,true);
   ArraySetAsSeries(StfRatesLow,true);
   ArraySetAsSeries(StfRatesOpen,true);   
   ArraySetAsSeries(StfRatesClose,true);
   ArraySetAsSeries(StfRatesTime,true);   

} //    
//+++------------------------------------------------------------------+++
//   
void Service::DeIndInit()
{
//   
   FileClose(LogHandle);
//---     Stf
   IndicatorRelease(Stf_ATR_Long_Handle);
   IndicatorRelease(Stf_DEMA1_Handle);
   IndicatorRelease(Stf_EMARSI_Handle);

} //    
//+++------------------------------------------------------------------+++
//   
void Service::GetIndBuffers()
{  
   if(CopyBuffer(Stf_ATR_Long_Handle,0,0,4,Stf_ATR_Long_Val)<0)
   {
      string Errormsg = "    ATR:";
      int Errcode = GetLastError();
      ShowError(Errormsg,Errcode);
   }
   if(CopyBuffer(Stf_DEMA1_Handle,0,0,4,Stf_DEMA1_Val)<0)
   {
      string Errormsg = "    DEMA:";
      int Errcode = GetLastError();
      ShowError(Errormsg,Errcode);
   }
   if(CopyBuffer(Stf_EMARSI_Handle,0,0,50,Stf_EMARSI_Val)<0)
   {
      string Errormsg = "    EMA RSI VA:";
      int Errcode = GetLastError();
      ShowError(Errormsg,Errcode);
   }
}  //---  - GetBuffers
//+++------------------------------------------------------------------+++
//+++------------------------------------------------------------------+++
//    
void Service::GetTradeParams(double baselotsize, int minfreebabla, int percentstop, int percenttake, double fixedvolume)
  {
   BaseLotSize=baselotsize;
   MinFreeBabla=minfreebabla;
   PercentStop=percentstop;      PercentStop=NormalizeDouble(PercentStop/100,2);
   PercentTake=percenttake;      PercentTake=NormalizeDouble(PercentTake/100,2);
   FixedVolume=fixedvolume;
  }
//+++------------------------------------------------------------------+++
//+++------------------------------------------------------------------+++
//   SL  ATR
double Service::SLCountATR()
  {
   double Rez=0;
   Rez=NormalizeDouble(Stf_ATR_Long_Val[1]*PercentStop,_Digits);
   return(Rez);  
  } //  SLCountATR
//+++------------------------------------------------------------------+++
//   TP  ATR
double Service::TPCountATR()
  {
   double Rez=0;
   Rez=NormalizeDouble(Stf_ATR_Long_Val[1]*PercentTake,_Digits);
   return(Rez);  
  } //  TPCountATR
//+++------------------------------------------------------------------+++


//+++------------------------------------------------------------------+++
//---     
int Service::OpenTrade(ENUM_ORDER_TYPE otype, double lot, double price, double sl, double tp)
  {
   TRequest.action=TRADE_ACTION_DEAL;
   TRequest.magic=11235;
   TRequest.symbol=Symb;
   TRequest.volume=lot;
   TRequest.type=otype;
   TRequest.price=price;
   TRequest.sl=sl;
   TRequest.tp=tp;
   TRequest.deviation=50;
   TRequest.type_filling=ORDER_FILLING_FOK;
//    !
   OrderSend(TRequest,TResult);
//    
   if(TResult.retcode==10009 || TResult.retcode==10008)
     {
      Alert("  ,   #:",TResult.order,"!!");
      FileWrite(LogHandle,"    ,   #:",TResult.order,"!!");
      FileWrite(LogHandle,"  : ",OrderGetInteger(ORDER_TIME_SETUP),"!!   : ",StfRatesTime[0]);
      FileWrite(LogHandle,"Lot= ",TRequest.volume);
      FileWrite(LogHandle," = ",TRequest.sl,"  = ",TRequest.tp);
      FileWrite(LogHandle,"  = ",TRequest.type);
      return(1);
     }
   else
     {
      Alert("  ,   #:",TResult.retcode,"!!");
      string Errormsg = "     ., :";
      int Errcode = GetLastError();
      FileWrite(LogHandle,"     .,  : ",Errcode,"!!   : ",StfRatesTime[0]);
      FileWrite(LogHandle,"Lot= ",TRequest.volume);
      FileWrite(LogHandle," = ",TRequest.sl,"  = ",TRequest.tp);
      FileWrite(LogHandle,"  = ",TRequest.type);
      ShowError(Errormsg,Errcode);
      return(-1);
     } 
  } //---  OpenTrade
//+++------------------------------------------------------------------+++
//   EMA RSI+++
int Service::PatEMARSIPlus()
  {
   FileWrite(LogHandle,"Stf_DEMA1_Val[2] = ",Stf_DEMA1_Val[2],"  Stf_DEMA1_Val[1] =", Stf_DEMA1_Val[1]);
   FileWrite(LogHandle,"Stf_EMARSI_Val[2] = ",Stf_EMARSI_Val[2],"  Stf_EMARSI_Val[1] =", Stf_EMARSI_Val[1]);

   int RezCount=0;
   if (Stf_DEMA1_Val[2]<Stf_EMARSI_Val[2] && Stf_DEMA1_Val[1]>Stf_EMARSI_Val[1])
      RezCount++;
   else if (Stf_DEMA1_Val[2]>Stf_EMARSI_Val[2] && Stf_DEMA1_Val[1]<Stf_EMARSI_Val[1])
      RezCount--;
   if (Stf_EMARSI_Val[1]>Stf_EMARSI_Val[2])
      RezCount++;
   else if (Stf_EMARSI_Val[1]<Stf_EMARSI_Val[2])
      RezCount--;
/*
   if (Stf_Kelt_Mid[1]>Stf_Kelt_Mid[2])
      RezCount++;
   else if (Stf_Kelt_Mid[1]<Stf_Kelt_Mid[2])
      RezCount--;
*/
   if (RezCount==2)
      return(1);
   else if (RezCount==-2)
      return(2);
   else return(0);
  }  //  PatEMARSIPlus()
//+++------------------------------------------------------------------+++
//+++------------------------------------------------------------------+++
// .    EMARSIPlus
int Service::ExecuteEMARSIPlus()
  {
//---   
   if(!SymbolInfoTick(Symb,LastTick))
     {
      FileWrite(LogHandle,"     - :",GetLastError(),"!!");
      return(0);
     }


   int PatEMARSIPlusRez=PatEMARSIPlus();


   if (PatEMARSIPlusRez==1)
     {
      FileWrite(LogHandle,"    !!!   : ",StfRatesTime[0]);
      double Price=LastTick.ask;
      double SL=NormalizeDouble(LastTick.ask-SLCountATR(),_Digits);
      double TP=NormalizeDouble(LastTick.ask+TPCountATR(),_Digits);
      double DealVolume=FixedVolume;
      if (DealVolume<0)
         return(-1);
      OpenTrade(ORDER_TYPE_BUY,DealVolume,Price,SL,TP);
      return(1);
     }
   else if (PatEMARSIPlusRez==2)
     {
      FileWrite(LogHandle,"    !!!   : ",StfRatesTime[0]);
      double Price=LastTick.bid;
      double SL=NormalizeDouble(LastTick.ask+SLCountATR(),_Digits);
      double TP=NormalizeDouble(LastTick.ask-TPCountATR(),_Digits);
      double DealVolume=FixedVolume;
      if (DealVolume<0)
         return(-1);
      OpenTrade(ORDER_TYPE_SELL,DealVolume,Price,SL,TP);
      return(2);
     }
   else
     FileWrite(LogHandle,"    !!!   : ",StfRatesTime[0]);
   return(0);
  } //  ExecuteEMARSIPlus()